Create Workflow
curl --request POST \
--url https://api.neuralfactory.ai/workflows/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"blueprint": {
"name": "<string>",
"steps": [
{
"id": "<string>",
"name": "<string>",
"config": {},
"validation": [
{
"field": "<string>",
"params": {},
"message": "<string>"
}
],
"depends_on": [
"<string>"
],
"error_handling": {
"on_error": "fail",
"max_retries": 0,
"retry_delay_ms": 1000,
"retry_backoff": "exponential",
"fallback_step": "<string>"
},
"description": "<string>",
"allowed_tools": [
"<string>"
],
"sensitivity": "normal"
}
],
"id": "<string>",
"description": "",
"version": "1.0.0",
"input_schema": {},
"output_schema": {},
"error_handling": {
"default_on_error": "fail",
"default_max_retries": 2,
"default_retry_delay_ms": 1000
},
"metadata": {},
"toolkits": [
{
"toolkit_id": "<string>",
"name": "",
"selected_tools": [
"<string>"
]
}
],
"visibility": "private",
"allowed_groups": [
"<string>"
],
"allowed_user_ids": [
"<string>"
]
},
"publish": true
}
'import requests
url = "https://api.neuralfactory.ai/workflows/create"
payload = {
"blueprint": {
"name": "<string>",
"steps": [
{
"id": "<string>",
"name": "<string>",
"config": {},
"validation": [
{
"field": "<string>",
"params": {},
"message": "<string>"
}
],
"depends_on": ["<string>"],
"error_handling": {
"on_error": "fail",
"max_retries": 0,
"retry_delay_ms": 1000,
"retry_backoff": "exponential",
"fallback_step": "<string>"
},
"description": "<string>",
"allowed_tools": ["<string>"],
"sensitivity": "normal"
}
],
"id": "<string>",
"description": "",
"version": "1.0.0",
"input_schema": {},
"output_schema": {},
"error_handling": {
"default_on_error": "fail",
"default_max_retries": 2,
"default_retry_delay_ms": 1000
},
"metadata": {},
"toolkits": [
{
"toolkit_id": "<string>",
"name": "",
"selected_tools": ["<string>"]
}
],
"visibility": "private",
"allowed_groups": ["<string>"],
"allowed_user_ids": ["<string>"]
},
"publish": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
blueprint: {
name: '<string>',
steps: [
{
id: '<string>',
name: '<string>',
config: {},
validation: [{field: '<string>', params: {}, message: '<string>'}],
depends_on: ['<string>'],
error_handling: {
on_error: 'fail',
max_retries: 0,
retry_delay_ms: 1000,
retry_backoff: 'exponential',
fallback_step: '<string>'
},
description: '<string>',
allowed_tools: ['<string>'],
sensitivity: 'normal'
}
],
id: '<string>',
description: '',
version: '1.0.0',
input_schema: {},
output_schema: {},
error_handling: {default_on_error: 'fail', default_max_retries: 2, default_retry_delay_ms: 1000},
metadata: {},
toolkits: [{toolkit_id: '<string>', name: '', selected_tools: ['<string>']}],
visibility: 'private',
allowed_groups: ['<string>'],
allowed_user_ids: ['<string>']
},
publish: true
})
};
fetch('https://api.neuralfactory.ai/workflows/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.neuralfactory.ai/workflows/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'blueprint' => [
'name' => '<string>',
'steps' => [
[
'id' => '<string>',
'name' => '<string>',
'config' => [
],
'validation' => [
[
'field' => '<string>',
'params' => [
],
'message' => '<string>'
]
],
'depends_on' => [
'<string>'
],
'error_handling' => [
'on_error' => 'fail',
'max_retries' => 0,
'retry_delay_ms' => 1000,
'retry_backoff' => 'exponential',
'fallback_step' => '<string>'
],
'description' => '<string>',
'allowed_tools' => [
'<string>'
],
'sensitivity' => 'normal'
]
],
'id' => '<string>',
'description' => '',
'version' => '1.0.0',
'input_schema' => [
],
'output_schema' => [
],
'error_handling' => [
'default_on_error' => 'fail',
'default_max_retries' => 2,
'default_retry_delay_ms' => 1000
],
'metadata' => [
],
'toolkits' => [
[
'toolkit_id' => '<string>',
'name' => '',
'selected_tools' => [
'<string>'
]
]
],
'visibility' => 'private',
'allowed_groups' => [
'<string>'
],
'allowed_user_ids' => [
'<string>'
]
],
'publish' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.neuralfactory.ai/workflows/create"
payload := strings.NewReader("{\n \"blueprint\": {\n \"name\": \"<string>\",\n \"steps\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\",\n \"config\": {},\n \"validation\": [\n {\n \"field\": \"<string>\",\n \"params\": {},\n \"message\": \"<string>\"\n }\n ],\n \"depends_on\": [\n \"<string>\"\n ],\n \"error_handling\": {\n \"on_error\": \"fail\",\n \"max_retries\": 0,\n \"retry_delay_ms\": 1000,\n \"retry_backoff\": \"exponential\",\n \"fallback_step\": \"<string>\"\n },\n \"description\": \"<string>\",\n \"allowed_tools\": [\n \"<string>\"\n ],\n \"sensitivity\": \"normal\"\n }\n ],\n \"id\": \"<string>\",\n \"description\": \"\",\n \"version\": \"1.0.0\",\n \"input_schema\": {},\n \"output_schema\": {},\n \"error_handling\": {\n \"default_on_error\": \"fail\",\n \"default_max_retries\": 2,\n \"default_retry_delay_ms\": 1000\n },\n \"metadata\": {},\n \"toolkits\": [\n {\n \"toolkit_id\": \"<string>\",\n \"name\": \"\",\n \"selected_tools\": [\n \"<string>\"\n ]\n }\n ],\n \"visibility\": \"private\",\n \"allowed_groups\": [\n \"<string>\"\n ],\n \"allowed_user_ids\": [\n \"<string>\"\n ]\n },\n \"publish\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.neuralfactory.ai/workflows/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"blueprint\": {\n \"name\": \"<string>\",\n \"steps\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\",\n \"config\": {},\n \"validation\": [\n {\n \"field\": \"<string>\",\n \"params\": {},\n \"message\": \"<string>\"\n }\n ],\n \"depends_on\": [\n \"<string>\"\n ],\n \"error_handling\": {\n \"on_error\": \"fail\",\n \"max_retries\": 0,\n \"retry_delay_ms\": 1000,\n \"retry_backoff\": \"exponential\",\n \"fallback_step\": \"<string>\"\n },\n \"description\": \"<string>\",\n \"allowed_tools\": [\n \"<string>\"\n ],\n \"sensitivity\": \"normal\"\n }\n ],\n \"id\": \"<string>\",\n \"description\": \"\",\n \"version\": \"1.0.0\",\n \"input_schema\": {},\n \"output_schema\": {},\n \"error_handling\": {\n \"default_on_error\": \"fail\",\n \"default_max_retries\": 2,\n \"default_retry_delay_ms\": 1000\n },\n \"metadata\": {},\n \"toolkits\": [\n {\n \"toolkit_id\": \"<string>\",\n \"name\": \"\",\n \"selected_tools\": [\n \"<string>\"\n ]\n }\n ],\n \"visibility\": \"private\",\n \"allowed_groups\": [\n \"<string>\"\n ],\n \"allowed_user_ids\": [\n \"<string>\"\n ]\n },\n \"publish\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.neuralfactory.ai/workflows/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"blueprint\": {\n \"name\": \"<string>\",\n \"steps\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\",\n \"config\": {},\n \"validation\": [\n {\n \"field\": \"<string>\",\n \"params\": {},\n \"message\": \"<string>\"\n }\n ],\n \"depends_on\": [\n \"<string>\"\n ],\n \"error_handling\": {\n \"on_error\": \"fail\",\n \"max_retries\": 0,\n \"retry_delay_ms\": 1000,\n \"retry_backoff\": \"exponential\",\n \"fallback_step\": \"<string>\"\n },\n \"description\": \"<string>\",\n \"allowed_tools\": [\n \"<string>\"\n ],\n \"sensitivity\": \"normal\"\n }\n ],\n \"id\": \"<string>\",\n \"description\": \"\",\n \"version\": \"1.0.0\",\n \"input_schema\": {},\n \"output_schema\": {},\n \"error_handling\": {\n \"default_on_error\": \"fail\",\n \"default_max_retries\": 2,\n \"default_retry_delay_ms\": 1000\n },\n \"metadata\": {},\n \"toolkits\": [\n {\n \"toolkit_id\": \"<string>\",\n \"name\": \"\",\n \"selected_tools\": [\n \"<string>\"\n ]\n }\n ],\n \"visibility\": \"private\",\n \"allowed_groups\": [\n \"<string>\"\n ],\n \"allowed_user_ids\": [\n \"<string>\"\n ]\n },\n \"publish\": true\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"name": "<string>",
"description": "",
"version": "1.0.0",
"status": "active",
"step_count": 0,
"steps": [
{}
],
"input_schema": {},
"output_schema": {},
"error_handling": {},
"metadata": {},
"toolkits": [
{}
],
"created_by": "<string>",
"created_by_email": "<string>",
"created_at": "<string>",
"updated_at": "<string>",
"visibility": "private",
"allowed_groups": [
"<string>"
],
"allowed_user_ids": [
"<string>"
],
"revision": 1,
"edit_seq": 0,
"published_revision": 123,
"from_use_case": {
"id": "<string>",
"version": 123
},
"governance_warnings": [
"<string>"
],
"last_run": {
"status": "<string>",
"completed_at": "<string>"
},
"run_count": 0,
"pending_approvals": 0,
"last_run_execution_id": "<string>",
"recent_statuses": [
"<string>"
],
"cost_30d": 123,
"tags": [
"<string>"
],
"is_favourite": false
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>",
"input": "<unknown>",
"ctx": {}
}
]
}Workflows
Create Workflow
API key permission: Agents (Admin also opens it).
POST
/
workflows
/
create
Create Workflow
curl --request POST \
--url https://api.neuralfactory.ai/workflows/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"blueprint": {
"name": "<string>",
"steps": [
{
"id": "<string>",
"name": "<string>",
"config": {},
"validation": [
{
"field": "<string>",
"params": {},
"message": "<string>"
}
],
"depends_on": [
"<string>"
],
"error_handling": {
"on_error": "fail",
"max_retries": 0,
"retry_delay_ms": 1000,
"retry_backoff": "exponential",
"fallback_step": "<string>"
},
"description": "<string>",
"allowed_tools": [
"<string>"
],
"sensitivity": "normal"
}
],
"id": "<string>",
"description": "",
"version": "1.0.0",
"input_schema": {},
"output_schema": {},
"error_handling": {
"default_on_error": "fail",
"default_max_retries": 2,
"default_retry_delay_ms": 1000
},
"metadata": {},
"toolkits": [
{
"toolkit_id": "<string>",
"name": "",
"selected_tools": [
"<string>"
]
}
],
"visibility": "private",
"allowed_groups": [
"<string>"
],
"allowed_user_ids": [
"<string>"
]
},
"publish": true
}
'import requests
url = "https://api.neuralfactory.ai/workflows/create"
payload = {
"blueprint": {
"name": "<string>",
"steps": [
{
"id": "<string>",
"name": "<string>",
"config": {},
"validation": [
{
"field": "<string>",
"params": {},
"message": "<string>"
}
],
"depends_on": ["<string>"],
"error_handling": {
"on_error": "fail",
"max_retries": 0,
"retry_delay_ms": 1000,
"retry_backoff": "exponential",
"fallback_step": "<string>"
},
"description": "<string>",
"allowed_tools": ["<string>"],
"sensitivity": "normal"
}
],
"id": "<string>",
"description": "",
"version": "1.0.0",
"input_schema": {},
"output_schema": {},
"error_handling": {
"default_on_error": "fail",
"default_max_retries": 2,
"default_retry_delay_ms": 1000
},
"metadata": {},
"toolkits": [
{
"toolkit_id": "<string>",
"name": "",
"selected_tools": ["<string>"]
}
],
"visibility": "private",
"allowed_groups": ["<string>"],
"allowed_user_ids": ["<string>"]
},
"publish": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
blueprint: {
name: '<string>',
steps: [
{
id: '<string>',
name: '<string>',
config: {},
validation: [{field: '<string>', params: {}, message: '<string>'}],
depends_on: ['<string>'],
error_handling: {
on_error: 'fail',
max_retries: 0,
retry_delay_ms: 1000,
retry_backoff: 'exponential',
fallback_step: '<string>'
},
description: '<string>',
allowed_tools: ['<string>'],
sensitivity: 'normal'
}
],
id: '<string>',
description: '',
version: '1.0.0',
input_schema: {},
output_schema: {},
error_handling: {default_on_error: 'fail', default_max_retries: 2, default_retry_delay_ms: 1000},
metadata: {},
toolkits: [{toolkit_id: '<string>', name: '', selected_tools: ['<string>']}],
visibility: 'private',
allowed_groups: ['<string>'],
allowed_user_ids: ['<string>']
},
publish: true
})
};
fetch('https://api.neuralfactory.ai/workflows/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.neuralfactory.ai/workflows/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'blueprint' => [
'name' => '<string>',
'steps' => [
[
'id' => '<string>',
'name' => '<string>',
'config' => [
],
'validation' => [
[
'field' => '<string>',
'params' => [
],
'message' => '<string>'
]
],
'depends_on' => [
'<string>'
],
'error_handling' => [
'on_error' => 'fail',
'max_retries' => 0,
'retry_delay_ms' => 1000,
'retry_backoff' => 'exponential',
'fallback_step' => '<string>'
],
'description' => '<string>',
'allowed_tools' => [
'<string>'
],
'sensitivity' => 'normal'
]
],
'id' => '<string>',
'description' => '',
'version' => '1.0.0',
'input_schema' => [
],
'output_schema' => [
],
'error_handling' => [
'default_on_error' => 'fail',
'default_max_retries' => 2,
'default_retry_delay_ms' => 1000
],
'metadata' => [
],
'toolkits' => [
[
'toolkit_id' => '<string>',
'name' => '',
'selected_tools' => [
'<string>'
]
]
],
'visibility' => 'private',
'allowed_groups' => [
'<string>'
],
'allowed_user_ids' => [
'<string>'
]
],
'publish' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.neuralfactory.ai/workflows/create"
payload := strings.NewReader("{\n \"blueprint\": {\n \"name\": \"<string>\",\n \"steps\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\",\n \"config\": {},\n \"validation\": [\n {\n \"field\": \"<string>\",\n \"params\": {},\n \"message\": \"<string>\"\n }\n ],\n \"depends_on\": [\n \"<string>\"\n ],\n \"error_handling\": {\n \"on_error\": \"fail\",\n \"max_retries\": 0,\n \"retry_delay_ms\": 1000,\n \"retry_backoff\": \"exponential\",\n \"fallback_step\": \"<string>\"\n },\n \"description\": \"<string>\",\n \"allowed_tools\": [\n \"<string>\"\n ],\n \"sensitivity\": \"normal\"\n }\n ],\n \"id\": \"<string>\",\n \"description\": \"\",\n \"version\": \"1.0.0\",\n \"input_schema\": {},\n \"output_schema\": {},\n \"error_handling\": {\n \"default_on_error\": \"fail\",\n \"default_max_retries\": 2,\n \"default_retry_delay_ms\": 1000\n },\n \"metadata\": {},\n \"toolkits\": [\n {\n \"toolkit_id\": \"<string>\",\n \"name\": \"\",\n \"selected_tools\": [\n \"<string>\"\n ]\n }\n ],\n \"visibility\": \"private\",\n \"allowed_groups\": [\n \"<string>\"\n ],\n \"allowed_user_ids\": [\n \"<string>\"\n ]\n },\n \"publish\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.neuralfactory.ai/workflows/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"blueprint\": {\n \"name\": \"<string>\",\n \"steps\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\",\n \"config\": {},\n \"validation\": [\n {\n \"field\": \"<string>\",\n \"params\": {},\n \"message\": \"<string>\"\n }\n ],\n \"depends_on\": [\n \"<string>\"\n ],\n \"error_handling\": {\n \"on_error\": \"fail\",\n \"max_retries\": 0,\n \"retry_delay_ms\": 1000,\n \"retry_backoff\": \"exponential\",\n \"fallback_step\": \"<string>\"\n },\n \"description\": \"<string>\",\n \"allowed_tools\": [\n \"<string>\"\n ],\n \"sensitivity\": \"normal\"\n }\n ],\n \"id\": \"<string>\",\n \"description\": \"\",\n \"version\": \"1.0.0\",\n \"input_schema\": {},\n \"output_schema\": {},\n \"error_handling\": {\n \"default_on_error\": \"fail\",\n \"default_max_retries\": 2,\n \"default_retry_delay_ms\": 1000\n },\n \"metadata\": {},\n \"toolkits\": [\n {\n \"toolkit_id\": \"<string>\",\n \"name\": \"\",\n \"selected_tools\": [\n \"<string>\"\n ]\n }\n ],\n \"visibility\": \"private\",\n \"allowed_groups\": [\n \"<string>\"\n ],\n \"allowed_user_ids\": [\n \"<string>\"\n ]\n },\n \"publish\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.neuralfactory.ai/workflows/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"blueprint\": {\n \"name\": \"<string>\",\n \"steps\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\",\n \"config\": {},\n \"validation\": [\n {\n \"field\": \"<string>\",\n \"params\": {},\n \"message\": \"<string>\"\n }\n ],\n \"depends_on\": [\n \"<string>\"\n ],\n \"error_handling\": {\n \"on_error\": \"fail\",\n \"max_retries\": 0,\n \"retry_delay_ms\": 1000,\n \"retry_backoff\": \"exponential\",\n \"fallback_step\": \"<string>\"\n },\n \"description\": \"<string>\",\n \"allowed_tools\": [\n \"<string>\"\n ],\n \"sensitivity\": \"normal\"\n }\n ],\n \"id\": \"<string>\",\n \"description\": \"\",\n \"version\": \"1.0.0\",\n \"input_schema\": {},\n \"output_schema\": {},\n \"error_handling\": {\n \"default_on_error\": \"fail\",\n \"default_max_retries\": 2,\n \"default_retry_delay_ms\": 1000\n },\n \"metadata\": {},\n \"toolkits\": [\n {\n \"toolkit_id\": \"<string>\",\n \"name\": \"\",\n \"selected_tools\": [\n \"<string>\"\n ]\n }\n ],\n \"visibility\": \"private\",\n \"allowed_groups\": [\n \"<string>\"\n ],\n \"allowed_user_ids\": [\n \"<string>\"\n ]\n },\n \"publish\": true\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"name": "<string>",
"description": "",
"version": "1.0.0",
"status": "active",
"step_count": 0,
"steps": [
{}
],
"input_schema": {},
"output_schema": {},
"error_handling": {},
"metadata": {},
"toolkits": [
{}
],
"created_by": "<string>",
"created_by_email": "<string>",
"created_at": "<string>",
"updated_at": "<string>",
"visibility": "private",
"allowed_groups": [
"<string>"
],
"allowed_user_ids": [
"<string>"
],
"revision": 1,
"edit_seq": 0,
"published_revision": 123,
"from_use_case": {
"id": "<string>",
"version": 123
},
"governance_warnings": [
"<string>"
],
"last_run": {
"status": "<string>",
"completed_at": "<string>"
},
"run_count": 0,
"pending_approvals": 0,
"last_run_execution_id": "<string>",
"recent_statuses": [
"<string>"
],
"cost_30d": 123,
"tags": [
"<string>"
],
"is_favourite": false
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>",
"input": "<unknown>",
"ctx": {}
}
]
}Authorizations
Query Parameters
Body
application/json
Response
Successful Response